<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// | Copyright (c) 2003 Mike Hommey                                       |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: error_notifier.php,v 1.1 2003/07/22 20:37:17 glandium Exp $

include_once(PAPAAN_BASE.'/components/generator.php');

/**
* This class returns xml for current error
*
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: error_notifier.php,v 1.1 2003/07/22 20:37:17 glandium Exp $
* @package  papaan
*/
class generator_error_notifier extends generator {


    /**
    * Constructor, does nothing at the moment
    */
    function generator_error_notifier (&$sitemap, $config) {
        $this->generator($sitemap, $config);
    }

    /**
    * generates an xml-DomDocument out of the xml-file
    *
    * @access public
    * @returns object DomDocument XML-Document
    */
    function DomStart(&$xml)
    {
	$xml = domxml_new_doc('1.0');
	$root = $xml->create_element_ns('http://apache.org/cocoon/error/2.0','error','notify');
	$xml->add_child($root);
	$root->set_attribute('error:type', $this->sitemap->error['type']);
	$root->set_attribute('error:sender', $this->sitemap->error['component']);
	$node = $xml->create_element('title');
	$root->add_child($node);
	$node->set_namespace('http://apache.org/cocoon/error/2.0');
	$new_node = $xml->create_text_node('Papaan error');
	$node->add_child($new_node);
	$node = $xml->create_element('message');
	$root->add_child($node);
	$node->set_namespace('http://apache.org/cocoon/error/2.0');
	$new_node = $xml->create_text_node($this->sitemap->error['message']);
	$node->add_child($new_node);
	$node = $xml->create_element('description');
	$root->add_child($node);
	$node->set_namespace('http://apache.org/cocoon/error/2.0');
	$new_node = $xml->create_text_node($this->sitemap->error['description']);
	$node->add_child($new_node);
        return True;
    }

    /* CACHING STUFF */

    /**
     * Generate cacheKey
     *
     * Calls the method inherited from 'Component'
     *
     * @param   array  attributes
     * @param   int    last cacheKey
     * @see     generateKeyDefault()
     */
    function generateKey($attribs, $keyBefore){
        return($this->generateKeyDefault($attribs, $keyBefore));
    }

    /** Generate validityObject  
     *
     * This is common to all "readers", you'll find the same code there.
     * I'm thinking about making a method in the class component named generateValidityFile() or alike
     * instead of having the same code everywhere..
     *
     * @author Hannes Gassert <hannes.gassert@unifr.ch>
     * @see  checkvalidity()
     * @return  array  $validityObject contains the components attributes plus file modification time and time of last access.
     */
    function generateValidity(){
        $validityObject = $this->attribs;
        $src = $this->getAttrib('src');
        $validityObject['filemtime'] = filemtime($src);
        $validityObject['fileatime'] = fileatime($src);
        return($validityObject);
    }

    /**
     * Check validity of a validityObject from cache
     *
     * This implements only the most simple form: If there's no fresher version, take that from cache.
     * I guess we'll need some more refined criteria..
     *
     * @return  bool  true if the validityObject indicates that the cached version can be used, false otherwise.
     * @param   object  validityObject
     */
    function checkValidity($validityObject){
        return(isset($validityObject['src'])       &&
               isset($validityObject['filemtime']) &&
               file_exists($validityObject['src']) &&
               ($validityObject['filemtime'] == filemtime($validityObject['src'])));
    }

}


?>
