<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: request.php,v 1.2 2003/07/23 18:27:30 glandium Exp $

/**
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: request.php,v 1.2 2003/07/23 18:27:30 glandium Exp $
* @package  papaan
*/
class request {

	var $attributes = array();

	function request($uri) {
		$this->parameters = array_merge($_GET, $_POST);
		//decode uri
		$this->uri = urldecode($uri);
		//remove leading slashes
		$this->uri = preg_replace('#^/+#','',$this->uri);
		//remove all stuff after ?
		if (strpos($this->uri, '?') !== false) {
			$this->uri = substr($this->uri, 0, strpos($this->uri, '?'));
		}
	}

	function get_attribute($name) {
		if (isset($this->attributes[$name])) {
			return $this->attributes[$name];
		}
		return null;
	}

	function get_attribute_names() {
		return array_keys($this->attributes);
	}

	function get_date_header($name, $format) {
		$this->sitemap->raiseError($this,'not-implemented','get_date_header not yet implemented');
	}

	function get_header($name) {
		if (isset($_SERVER['HTTP_'.strtoupper($name)])) {
			return $_SERVER['HTTP_'.strtoupper($name)];
		}
		return null;
	}

	function get_headers($name) {
		$this->sitemap->raiseError($this,'not-implemented','get_headers not yet implemented (I don\'t even know what it is supposed to do)');
	}

	function get_int_header($name) {
		$this->sitemap->raiseError($this,'not-implemented','get_int_header not yet implemented (I don\'t even know what it is supposed to do)');
	}

	function get_locale() {
		$this->sitemap->raiseError($this,'not-implemented','get_locale not yet implemented');
	}

	function get_locales() {
		$this->sitemap->raiseError($this,'not-implemented','get_locales not yet implemented');
	}

	function get_parameter($name) {
		if (isset($this->parameters[$name])) {
			return $this->parameters[$name];
		}
		return null;
	}

	function get_parameter_names() {
		return array_keys($this->parameters);
	}


	function get_parameter_values() {
		$this->sitemap->raiseError($this,'not-implemented','get_parameter_values not yet implemented');
	}

	function get_server_var($var) {
		if (isset($_SERVER[$var])) {
			return $_SERVER[$var];
		}
		return null;
	}

	function get_uri() {
		return $this->uri;
	}

	function remove_attribute($name) {
		unset($this->attributes[$name]);
	}

	function set_attribute($name, $value) {
		$this->attributes[$name] = $value;
	}

}
