<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: html.php,v 1.9 2003/07/20 16:14:38 glandium Exp $

include_once(PAPAAN_BASE.'/components/serializer.php');

/**
* Documentation is missing at the moment...
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: html.php,v 1.9 2003/07/20 16:14:38 glandium Exp $
* @package  papaan
*/
class serializer_html extends serializer {

  /* Default encoding output is UTF-8 */
  var $encoding = 'UTF-8';
    
  function serializer_html (&$sitemap, $config) {
    $this->serializer($sitemap, $config);
    // Quick and dirty way ; should check more cleanly if there's no garbage in configuration
    if (isset($this->config['dom'])) {
      $xpath = xpath_new_context($this->config['dom']);
      $xnode = xpath_eval($xpath,'/config/encoding');
      if (count($xnode->nodeset)) {
	$encoding = $xnode->nodeset[0]->get_content();
	if ($encoding) {
	  $this->encoding = $encoding;
	}
      }
      $xnode = xpath_eval($xpath,'/config/doctype-system');
      if (count($xnode->nodeset)) {
	$doctype_system = $xnode->nodeset[0]->get_content();
	if ($doctype_system) {
	  $this->doctype_system = $doctype_system;
	}
      }
      $xnode = xpath_eval($xpath,'/config/doctype-public');
      if (count($xnode->nodeset)) {
	$doctype_public = $xnode->nodeset[0]->get_content();
	if ($doctype_public) {
	  $this->doctype_public = $doctype_public;
	}
      }
    }
    if (isset($this->config['mime-type'])) {
      $this->sitemap->setContentType($this->config['mime-type'].'; charset='.$this->encoding);
    } else {
      $this->sitemap->setContentType('text/html');
    }
  }
	
  function DomStart(&$xml)
    {
      parent::DomStart($xml);
      $this->sitemap->hasFinalDom = true;
      $root = $xml->document_element();
      $dtd = $xml->doctype();
      if ($dtd) {
	$dtd->unlink();
      }

      if (isset($this->doctype_system)) {
	if (isset($this->doctype_public)) {
	  $tmp = '<!DOCTYPE '.$root->node_name().' PUBLIC "'.$this->doctype_public.'" "'.$this->doctype_system.'">';
	} else {
	  $tmp = '<!DOCTYPE '.$root->node_name().' SYSTEM "'.$this->doctype_system.'">';
	}
      }
      return $tmp . $xml->html_dump_mem(0,$this->encoding);
    }
}

?>
